// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/recovery
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/items -i Items -t ../../../assets/templates/middleware/recovery -o recovering_middleware.go -l ""

import (
	"context"
	"fmt"

	"git.perx.ru/perxis/perxis-go/pkg/items"
	"git.perx.ru/perxis/perxis-go/pkg/schema"
	"go.uber.org/zap"
)

// recoveringMiddleware implements items.Items that is instrumented with logging
type recoveringMiddleware struct {
	logger *zap.Logger
	next   items.Items
}

// RecoveringMiddleware instruments an implementation of the items.Items with simple logging
func RecoveringMiddleware(logger *zap.Logger) Middleware {
	return func(next items.Items) items.Items {
		return &recoveringMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *recoveringMiddleware) Aggregate(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.AggregateOptions) (result map[string]interface{}, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Aggregate(ctx, spaceId, envId, collectionId, filter, options...)
}

func (m *recoveringMiddleware) AggregatePublished(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.AggregatePublishedOptions) (result map[string]interface{}, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.AggregatePublished(ctx, spaceId, envId, collectionId, filter, options...)
}

func (m *recoveringMiddleware) Archive(ctx context.Context, item *items.Item, options ...*items.ArchiveOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Archive(ctx, item, options...)
}

func (m *recoveringMiddleware) CheckoutRevision(ctx context.Context, spaceID string, envID string, collectionID string, id string, revID string, options ...*items.CheckoutRevisionsOptions) (storedRevID string, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.CheckoutRevision(ctx, spaceID, envID, collectionID, id, revID, options...)
}

func (m *recoveringMiddleware) Create(ctx context.Context, item *items.Item, opts ...*items.CreateOptions) (created *items.Item, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Create(ctx, item, opts...)
}

func (m *recoveringMiddleware) Delete(ctx context.Context, item *items.Item, options ...*items.DeleteOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Delete(ctx, item, options...)
}

func (m *recoveringMiddleware) Find(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.FindOptions) (items []*items.Item, total int, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Find(ctx, spaceId, envId, collectionId, filter, options...)
}

func (m *recoveringMiddleware) FindArchived(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.FindArchivedOptions) (items []*items.Item, total int, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.FindArchived(ctx, spaceId, envId, collectionId, filter, options...)
}

func (m *recoveringMiddleware) FindPublished(ctx context.Context, spaceId string, envId string, collectionId string, filter *items.Filter, options ...*items.FindPublishedOptions) (items []*items.Item, total int, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.FindPublished(ctx, spaceId, envId, collectionId, filter, options...)
}

func (m *recoveringMiddleware) Get(ctx context.Context, spaceId string, envId string, collectionId string, id string, options ...*items.GetOptions) (item *items.Item, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Get(ctx, spaceId, envId, collectionId, id, options...)
}

func (m *recoveringMiddleware) GetArchived(ctx context.Context, spaceID string, envID string, collectionID string, id string, options ...*items.GetArchivedOptions) (item *items.Item, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.GetArchived(ctx, spaceID, envID, collectionID, id, options...)
}

func (m *recoveringMiddleware) GetPublished(ctx context.Context, spaceId string, envId string, collectionId string, id string, options ...*items.GetPublishedOptions) (item *items.Item, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.GetPublished(ctx, spaceId, envId, collectionId, id, options...)
}

func (m *recoveringMiddleware) GetRevision(ctx context.Context, spaceId string, envId string, collectionId string, id string, revisionId string, options ...*items.GetRevisionOptions) (item *items.Item, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.GetRevision(ctx, spaceId, envId, collectionId, id, revisionId, options...)
}

func (m *recoveringMiddleware) Introspect(ctx context.Context, item *items.Item, opts ...*items.IntrospectOptions) (itm *items.Item, sch *schema.Schema, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Introspect(ctx, item, opts...)
}

func (m *recoveringMiddleware) ListRevisions(ctx context.Context, spaceId string, envId string, collectionId string, id string, options ...*items.ListRevisionsOptions) (items []*items.Item, total int, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.ListRevisions(ctx, spaceId, envId, collectionId, id, options...)
}

func (m *recoveringMiddleware) Publish(ctx context.Context, item *items.Item, options ...*items.PublishOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Publish(ctx, item, options...)
}

func (m *recoveringMiddleware) Unarchive(ctx context.Context, item *items.Item, options ...*items.UnarchiveOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Unarchive(ctx, item, options...)
}

func (m *recoveringMiddleware) Undelete(ctx context.Context, item *items.Item, options ...*items.UndeleteOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Undelete(ctx, item, options...)
}

func (m *recoveringMiddleware) Unpublish(ctx context.Context, item *items.Item, options ...*items.UnpublishOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Unpublish(ctx, item, options...)
}

func (m *recoveringMiddleware) Update(ctx context.Context, item *items.Item, options ...*items.UpdateOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Update(ctx, item, options...)
}
